#include <EEPROM.h>
#include "EEPROMAnything.h"
#include <IRremote.h>

int RECV_PIN = 2;
IRrecv irrecv(RECV_PIN);
decode_results results;
struct config_t
{
    unsigned long but1; // кнопка 1 Runlight (пульт)
    unsigned long but2; // кнопка 2 Runlight дольше 3 секунд (пульт)
    unsigned long but3; // кнопка 3 Fadespeed (пульт)
    unsigned long but4; // кнопка 4 Fadespeed дольше 3 секунд (пульт)
    unsigned long but5; // кнопка 5 Runlight+Fadespeed дольше 3 секунд (пульт)
    unsigned long but6; // кнопка 6 Переключение входов (пульт)
    unsigned long but7; // кнопка 7 Только эффекты (пульт)
} configuration;

int mode = 1;

void setup()
{
    PORTD |= (1<<PD4)|(1<<PD5);
    PORTB |= (1<<PB0);
    irrecv.enableIRIn(); // Start the receiver
    delay(3000); // задержка для программирования пульта
     
 if (digitalRead(6) == HIGH) //включает программирование пульта
     PORTD |= (1<<PD3); // индикация программирования
     else {goto en;} // если ненажата кнопка, пропускаем программирование

    label6:   
   if (irrecv.decode(&results)) { // Принимаем команду с пульта
    configuration.but1 = results.value; // Присваиваем переменной  кнопка 1
    }else{goto label6;} // Если команды не было возвращаемся к приему
    PORTD &= ~(1<<PD3); // команда принята, гасим лед
    delay(300); // Задержка перед приемом новой команды
    irrecv.resume(); // Готовы принять команду
    PORTD |= (1<<PD3); // Включаем лед

    label7:   
   if (irrecv.decode(&results)) {
    configuration.but2 = results.value; // кнопка 2
    }else{goto label7;}
    PORTD &= ~(1<<PD3);
    delay(300);
    irrecv.resume();
    PORTD |= (1<<PD3);

    label8:   
   if (irrecv.decode(&results)) {
    configuration.but3 = results.value; // кнопка 3
    }else{goto label8;}
    PORTD &= ~(1<<PD3);
    delay(300);
    irrecv.resume();
    PORTD |= (1<<PD3);

    label9:   
   if (irrecv.decode(&results)) {
    configuration.but4 = results.value; // кнопка 4
    }else{goto label9;}
    PORTD &= ~(1<<PD3);
    delay(300);
    irrecv.resume();
    PORTD |= (1<<PD3); 

    label10:   
   if (irrecv.decode(&results)) {
    configuration.but5 = results.value; // кнопка 5
    }else{goto label10;}
    PORTD &= ~(1<<PD3);
    delay(300);
    irrecv.resume();
    PORTD |= (1<<PD3);

    label11:   
   if (irrecv.decode(&results)) {
    configuration.but6 = results.value; // кнопка 6
    }else{goto label11;}
    PORTD &= ~(1<<PD3);
    delay(300);
    irrecv.resume();
    PORTD |= (1<<PD3);

    label12:   
   if (irrecv.decode(&results)) {
    configuration.but7 = results.value; // кнопка 7
    }else{goto label12;}
    PORTD &= ~(1<<PD3);
    delay(300);
    PORTD |= (1<<PD3);
    
    EEPROM_writeAnything(0, configuration); // запись команд в память 
     
    for (int ch = 0; ch < 10; ch++) { // индикация окончания программирования
    PORTD |= (1<<PD3);
    delay(50);
    PORTD &= ~(1<<PD3);
    delay(50);
    }
  
    en: // если не было программирования
 
    EEPROM_readAnything(0, configuration); // читаем команды из памяти
    irrecv.resume(); // Receive the next value
}

void loop()
{
 if (irrecv.decode(&results)) { // Принимаем команду с пульта

    for (int ch = 0; ch < 5; ch++) { // индикация приема
    PORTD |= (1<<PD3);
    delay(30);
    PORTD &= ~(1<<PD3);
    delay(30);
    }
    
 if (results.value == configuration.but1) { // если команда распознана (Runlight) 
    PORTD &= ~(1<<PD4); // имитируем
    delay(100); // нажатие
    PORTD |= (1<<PD4); // кнопки
}
  else if (results.value == configuration.but2) { // Runlight дольше 3 секунд 
    PORTD &= ~(1<<PD4);
    delay(3300);
    PORTD |= (1<<PD4);
  }

  else if (results.value == configuration.but3) {  // Fadespeed
    PORTD &= ~(1<<PD5);
    delay(100);
    PORTD |= (1<<PD5);
}
  else if (results.value == configuration.but4) {  // Fadespeed дольше 3 секунд
    PORTD &= ~(1<<PD5);
    delay(3300);
    PORTD |= (1<<PD5);
  }

  else if (results.value == configuration.but5) { // Runlight+Fadespeed дольше 3 секунд
     PORTD &= ~((1<<PD4)|(1<<PD5));
     delay(3300);
     PORTD |= (1<<PD4)|(1<<PD5);
   
  }

  else if (results.value == configuration.but6 && mode == 1) { // переключение входов
     PORTB &= ~(1<<PB0);
     PORTB |= (1<<PB1);
     mode = 2;
     PORTB &= ~(1<<PB4);
   
  }

  else if (results.value == configuration.but6 && mode == 2) { // переключение входов
     PORTB &= ~(1<<PB1);
     PORTB |= (1<<PB0);
     mode = 1;
     PORTB &= ~(1<<PB4);
   
  }

else if (results.value == configuration.but7) { // включение эффектов
     PORTB &= ~((1<<PB0)|(1<<PB1));
     PORTB |= (1<<PB4);
   
  }
  
  irrecv.resume(); // Receive the next value
}
}




